﻿/*
 * charset.h -- The charset opreation set.
 *
 * Copyright (c) 2018, Liu chao <lc-soft@live.cn> All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of LCUI nor the names of its contributors may be used
 *     to endorse or promote products derived from this software without
 *     specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef LCUI_UTIL_CHARSET_H
#define LCUI_UTIL_CHARSET_H

LCUI_BEGIN_HEADER

enum EncodingType { ENCODING_ANSI, ENCODING_UTF8 };

#define LCUI_DecodeUTF8String(WSTR, STR, MAX_LEN) \
	LCUI_DecodeString(WSTR, STR, MAX_LEN, ENCODING_UTF8)

#define LCUI_EncodeUTF8String(STR, WSTR, MAX_LEN) \
	LCUI_EncodeString(STR, WSTR, MAX_LEN, ENCODING_UTF8)

LCUI_API size_t LCUI_DecodeString(wchar_t *wstr, const char *str,
				  size_t max_len, int encoding);

LCUI_API size_t LCUI_EncodeString(char *str, const wchar_t *wstr,
				  size_t max_len, int encoding);
LCUI_END_HEADER

#endif
